from termcolor import colored


def apply_operation(op: str, a: float, b: float) -> float:
    if op == '+':
        return a + b
    elif op == '-':
        return a - b
    elif op == '/':
        return a / b
    elif op == '*':
        return a * b
    else:
        raise NotImplementedError("That operation is not implemented yet!")


def as_number(x: str) -> float:
    try:
        return float(x)
    except ValueError:
        raise TypeError("not a float")


def as_int(x: float) -> int | float:
    if int(x) == x:
        return int(x)
    else:
        return x


def compute_answer(expr: str) -> float:
    pieces: list[str] = expr.split(" ")
    while '' in pieces:
        pieces.remove('')

    if len(pieces) > 3:
        raise ValueError("You provided too many arguments!")

    a: float = as_number(pieces[0])
    b: float = as_number(pieces[2])

    op: str = pieces[1]
    answer: float = apply_operation(op, a, b)

    return as_int(answer)


while True:
    expr: str = input("Enter a mathematical expression: ")
    try:
        ans: float = compute_answer(expr)
        print(">> " + str(ans))
    except NotImplementedError:
        print(colored("That's not a valid operation!", "red"))
    except IndexError:
        print(colored("That's not enough arguments!", "red"))
    except ValueError as e:
        print(colored("I only support simple math. :(", "blue"))
    except TypeError as e:
        print(colored("Variable are too hard for me to handle. :(", "yellow"))
    except ZeroDivisionError:
        print("bah.")